use farming::{FarmlandId, Place, PlantId, PlantState};
use inventory::ContainerId;
use navigation::{MeshId, ObstacleId};
use physics::{BarrierId, BodyId, SpaceId, SpaceRelation};
use piloting::SpacecraftId;
use serde::{Deserialize, Serialize};
use universe::{
    BedId, BedKey, BridgeId, BridgeKey, CharacterId, CharacterKey, ColonyId, ColonyKey,
    ConstructionId, ConstructionKey, ConstructionProject, Coordinates, CropId, CropKey, DeckId,
    DeckKey, GroupId, PlanetId, PlanetKey, PlanterId, PlanterKey, PropId, PropKey, SpaceshipId,
    SpaceshipKey, StorageId, StorageKey, SystemId, SystemKey, Task, WorkbenchId, WorkbenchKey,
};

#[derive(Debug, Clone, Serialize, Deserialize, PartialEq)]
#[serde(tag = "$type")]
pub enum Appearance {
    ColonyAppeared {
        id: ColonyId,
        key: ColonyKey,
        space: SpaceId,
        mesh: MeshId,
        farmland: FarmlandId,
    },
    SystemAppeared {
        id: SystemId,
        key: SystemKey,
        space: SpaceId,
    },
    DeckAppeared {
        id: DeckId,
        key: DeckKey,
        space: SpaceId,
        mesh: MeshId,
        farmland: FarmlandId,
        parent: Option<SpaceRelation>,
        spaceship: SpaceshipId,
    },
    PlanetAppeared {
        id: PlanetId,
        key: PlanetKey,
        body: BodyId,
        space: SpaceId,
        position: Coordinates,
        colonies: Vec<ColonyId>,
    },
    SpaceshipAppeared {
        id: SpaceshipId,
        key: SpaceshipKey,
        body: BodyId,
        spacecraft: SpacecraftId,
        space: SpaceId,
        position: Coordinates,
    },
    GroupAppeared {
        id: GroupId,
        name: String,
    },
    CharacterAppeared {
        id: CharacterId,
        key: CharacterKey,
        body: BodyId,
        group: GroupId,
        space: SpaceId,
        container: ContainerId,
        task: Task,
        position: Coordinates,
        health: f32,
        health_limit: f32,
        energy: f32,
        energy_limit: f32,
        stress: f32,
        stress_limit: f32,
    },
    CropAppeared {
        id: CropId,
        key: CropKey,
        barrier: BarrierId,
        plant: PlantId,
        state: PlantState,
        place: Place,
        space: SpaceId,
        position: Coordinates,
        rotation: f32,
    },
    StorageAppeared {
        id: StorageId,
        key: StorageKey,
        barrier: BarrierId,
        container: ContainerId,
        space: SpaceId,
        position: Coordinates,
        rotation: f32,
        entry: Coordinates,
    },
    BridgeAppeared {
        id: BridgeId,
        key: BridgeKey,
        barrier: BarrierId,
        space: SpaceId,
        position: Coordinates,
        rotation: f32,
        entry: Coordinates,
        spaceship: Option<SpaceshipId>,
    },
    WorkbenchAppeared {
        id: WorkbenchId,
        key: WorkbenchKey,
        barrier: BarrierId,
        space: SpaceId,
        position: Coordinates,
        rotation: f32,
        entry: Coordinates,
    },
    PropAppeared {
        id: PropId,
        key: PropKey,
        barrier: BarrierId,
        obstacle: ObstacleId,
        space: SpaceId,
        position: Coordinates,
        rotation: f32,
    },
    PlanterAppeared {
        id: PlanterId,
        key: PlanterKey,
        barrier: BarrierId,
        space: SpaceId,
        position: Coordinates,
        rotation: f32,
        entry: Coordinates,
    },
    BedAppeared {
        id: BedId,
        key: BedKey,
        barrier: BarrierId,
        space: SpaceId,
        position: Coordinates,
        rotation: f32,
        entry: Coordinates,
        user: Option<CharacterId>,
    },
    ConstructionAppeared {
        id: ConstructionId,
        space: SpaceId,
        key: ConstructionKey,
        progress: f32,
        project: ConstructionProject,
        barrier: BarrierId,
        position: Coordinates,
        rotation: f32,
    },
}
